Index: issm/trunk/src/c/modules/Delta18oParameterizationx/Delta18oParameterizationx.h
===================================================================
--- issm/trunk/src/c/modules/Delta18oParameterizationx/Delta18oParameterizationx.h	(revision 13395)
+++ issm/trunk/src/c/modules/Delta18oParameterizationx/Delta18oParameterizationx.h	(revision 13395)
@@ -0,0 +1,14 @@
+/*!\file:  Delta18oParameterizationx.cpp
+ * \brief header file for 
+ */ 
+
+#ifndef _DELTA18OPARAMETERIZATIONX_H
+#define _DELTA18OPARAMETERIZATIONX_H
+
+#include "../../Container/Container.h"
+#include "../../classes/objects/objects.h"
+
+/* local prototypes: */
+void Delta18oParameterizationx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters);
+
+#endif  /* _DELTA18OPARAMETERIZATIONX_H*/
Index: issm/trunk/src/c/modules/DragCoefficientAbsGradientx/DragCoefficientAbsGradientx.cpp
===================================================================
--- issm/trunk/src/c/modules/DragCoefficientAbsGradientx/DragCoefficientAbsGradientx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/DragCoefficientAbsGradientx/DragCoefficientAbsGradientx.cpp	(revision 13395)
@@ -10,5 +10,5 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void DragCoefficientAbsGradientx( double* pJ, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units, int weight_index){
+void DragCoefficientAbsGradientx( IssmDouble* pJ, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units, int weight_index){
 
 	/*Intermediary*/
@@ -17,6 +17,6 @@
 
 	/*output: */
-	double J=0;
-	double J_sum;
+	IssmDouble J=0;
+	IssmDouble J_sum;
 
 	/*Compute Misfit: */
Index: issm/trunk/src/c/modules/DragCoefficientAbsGradientx/DragCoefficientAbsGradientx.h
===================================================================
--- issm/trunk/src/c/modules/DragCoefficientAbsGradientx/DragCoefficientAbsGradientx.h	(revision 12709)
+++ issm/trunk/src/c/modules/DragCoefficientAbsGradientx/DragCoefficientAbsGradientx.h	(revision 13395)
@@ -7,8 +7,8 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void DragCoefficientAbsGradientx( double* pJ, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units,int weight_index);
+void DragCoefficientAbsGradientx( IssmDouble* pJ, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units,int weight_index);
 
 #endif
Index: issm/trunk/src/c/modules/ElementResponsex/ElementResponsex.cpp
===================================================================
--- issm/trunk/src/c/modules/ElementResponsex/ElementResponsex.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/ElementResponsex/ElementResponsex.cpp	(revision 13395)
@@ -10,5 +10,5 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void ElementResponsex( double* presponse, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,int response_enum,bool process_units){
+void ElementResponsex( IssmDouble* presponse, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,int response_enum,bool process_units){
 	
 
@@ -20,5 +20,5 @@
 	int cpu_found=-1;
 	int index;
-	double response;
+	IssmDouble response;
 	Element* element=NULL;
 
@@ -39,5 +39,5 @@
 	#ifdef _HAVE_MPI_
 	MPI_Allreduce ( &found,&sumfound,1,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
-	if(!sumfound)_error2_("could not find material with id" << index << " to compute ElementResponse");
+	if(!sumfound)_error_("could not find material with id" << index << " to compute ElementResponse");
 	#endif
 
Index: issm/trunk/src/c/modules/ElementResponsex/ElementResponsex.h
===================================================================
--- issm/trunk/src/c/modules/ElementResponsex/ElementResponsex.h	(revision 12709)
+++ issm/trunk/src/c/modules/ElementResponsex/ElementResponsex.h	(revision 13395)
@@ -7,8 +7,8 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void ElementResponsex( double* presponse, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,int response_enum,bool process_units);
+void ElementResponsex( IssmDouble* presponse, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,int response_enum,bool process_units);
 
 #endif  /* _ELEMENTRESPONSEX_H */
Index: issm/trunk/src/c/modules/EnumToStringx/EnumToStringx.cpp
===================================================================
--- issm/trunk/src/c/modules/EnumToStringx/EnumToStringx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/EnumToStringx/EnumToStringx.cpp	(revision 13395)
@@ -17,7 +17,12 @@
 	switch(en){
 
-		case AutodiffForwardEnum : return "AutodiffForward";
 		case AutodiffIsautodiffEnum : return "AutodiffIsautodiff";
-		case AutodiffReverseEnum : return "AutodiffReverse";
+		case AutodiffDependentsEnum : return "AutodiffDependents";
+		case AutodiffNumDependentsEnum : return "AutodiffNumDependents";
+		case AutodiffIndependentsEnum : return "AutodiffIndependents";
+		case AutodiffNumIndependentsEnum : return "AutodiffNumIndependents";
+		case AutodiffJacobianEnum : return "AutodiffJacobian";
+		case AutodiffXpEnum : return "AutodiffXp";
+		case AutodiffFosForwardOutputEnum : return "AutodiffFosForwardOutput";
 		case BalancethicknessSpcthicknessEnum : return "BalancethicknessSpcthickness";
 		case BalancethicknessStabilizationEnum : return "BalancethicknessStabilization";
@@ -55,4 +60,5 @@
 		case FlowequationElementEquationEnum : return "FlowequationElementEquation";
 		case FlowequationIshutterEnum : return "FlowequationIshutter";
+		case FlowequationIsl1l2Enum : return "FlowequationIsl1l2";
 		case FlowequationIsmacayealpattynEnum : return "FlowequationIsmacayealpattyn";
 		case FlowequationIsstokesEnum : return "FlowequationIsstokes";
@@ -106,4 +112,6 @@
 		case MaterialsRheologyLawEnum : return "MaterialsRheologyLaw";
 		case MaterialsRheologyNEnum : return "MaterialsRheologyN";
+		case MaterialsRheologyZEnum : return "MaterialsRheologyZ";
+		case MaterialsRheologyZbarEnum : return "MaterialsRheologyZbar";
 		case MaterialsRhoIceEnum : return "MaterialsRhoIce";
 		case MaterialsRhoWaterEnum : return "MaterialsRhoWater";
@@ -154,4 +162,10 @@
 		case SettingsResultsAsPatchesEnum : return "SettingsResultsAsPatches";
 		case SettingsWaitonlockEnum : return "SettingsWaitonlock";
+		case SurfaceforcingsDelta18oEnum : return "SurfaceforcingsDelta18o";
+		case SurfaceforcingsDelta18oSurfaceEnum : return "SurfaceforcingsDelta18oSurface";
+		case SurfaceforcingsIsdelta18oEnum : return "SurfaceforcingsIsdelta18o";
+		case SurfaceforcingsPrecipitationsPresentdayEnum : return "SurfaceforcingsPrecipitationsPresentday";
+		case SurfaceforcingsTemperaturesPresentdayEnum : return "SurfaceforcingsTemperaturesPresentday";
+		case SurfaceforcingsTemperaturesLgmEnum : return "SurfaceforcingsTemperaturesLgm";
 		case DebugProfilingEnum : return "DebugProfiling";
 		case ProfilingCurrentMemEnum : return "ProfilingCurrentMem";
@@ -231,9 +245,10 @@
 		case TransientSolutionEnum : return "TransientSolution";
 		case ApproximationEnum : return "Approximation";
+		case NoneApproximationEnum : return "NoneApproximation";
 		case HutterApproximationEnum : return "HutterApproximation";
 		case MacAyealApproximationEnum : return "MacAyealApproximation";
 		case MacAyealPattynApproximationEnum : return "MacAyealPattynApproximation";
 		case MacAyealStokesApproximationEnum : return "MacAyealStokesApproximation";
-		case NoneApproximationEnum : return "NoneApproximation";
+		case L1L2ApproximationEnum : return "L1L2Approximation";
 		case PattynApproximationEnum : return "PattynApproximation";
 		case PattynStokesApproximationEnum : return "PattynStokesApproximation";
@@ -246,4 +261,6 @@
 		case VerticesEnum : return "Vertices";
 		case ResultsEnum : return "Results";
+		case GenericParamEnum : return "GenericParam";
+		case AdolcParamEnum : return "AdolcParam";
 		case BoolInputEnum : return "BoolInput";
 		case BoolParamEnum : return "BoolParam";
@@ -267,11 +284,14 @@
 		case IntParamEnum : return "IntParam";
 		case IntVecParamEnum : return "IntVecParam";
+		case TransientParamEnum : return "TransientParam";
 		case MacAyeal2dIceFrontEnum : return "MacAyeal2dIceFront";
 		case MacAyeal3dIceFrontEnum : return "MacAyeal3dIceFront";
 		case MaticeEnum : return "Matice";
+		case MatdamageiceEnum : return "Matdamageice";
 		case MatparEnum : return "Matpar";
 		case NodeEnum : return "Node";
 		case NumericalfluxEnum : return "Numericalflux";
 		case ParamEnum : return "Param";
+		case L1L2IceFrontEnum : return "L1L2IceFront";
 		case PattynIceFrontEnum : return "PattynIceFront";
 		case PengridEnum : return "Pengrid";
@@ -344,4 +364,6 @@
 		case TemperatureOldEnum : return "TemperatureOld";
 		case TemperaturePicardEnum : return "TemperaturePicard";
+		case TemperatureSurfaceEnum : return "TemperatureSurface";
+		case TemperatureBasalEnum : return "TemperatureBasal";
 		case ThicknessAbsMisfitEnum : return "ThicknessAbsMisfit";
 		case TypeEnum : return "Type";
@@ -365,4 +387,6 @@
 		case EnthalpyPicardEnum : return "EnthalpyPicard";
 		case ThicknessAbsGradientEnum : return "ThicknessAbsGradient";
+		case ThicknessAlongGradientEnum : return "ThicknessAlongGradient";
+		case ThicknessAcrossGradientEnum : return "ThicknessAcrossGradient";
 		case StepResponsesEnum : return "StepResponses";
 		case IntMatParamEnum : return "IntMatParam";
@@ -385,5 +409,4 @@
 		case StressTensoryzEnum : return "StressTensoryz";
 		case StressTensorzzEnum : return "StressTensorzz";
-		case IceVolumeEnum : return "IceVolume";
 		case P0Enum : return "P0";
 		case P1Enum : return "P1";
@@ -419,4 +442,6 @@
 		case MaxVzEnum : return "MaxVz";
 		case MaxAbsVzEnum : return "MaxAbsVz";
+		case IceVolumeEnum : return "IceVolume";
+		case TotalSmbEnum : return "TotalSmb";
 		case RelativeEnum : return "Relative";
 		case AbsoluteEnum : return "Absolute";
@@ -458,4 +483,5 @@
 		case XYZPEnum : return "XYZP";
 		case OptionEnum : return "Option";
+		case GenericOptionEnum : return "GenericOption";
 		case OptionCellEnum : return "OptionCell";
 		case OptionCharEnum : return "OptionChar";
Index: issm/trunk/src/c/modules/Exp2Kmlx/Exp2Kmlx.cpp
===================================================================
--- issm/trunk/src/c/modules/Exp2Kmlx/Exp2Kmlx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/Exp2Kmlx/Exp2Kmlx.cpp	(revision 13395)
@@ -55,5 +55,5 @@
 
 	if (!DomainOutlineRead(&nprof,&pnvert,&pprofx,&pprofy,&closed,filexp))
-		_error2_("Error reading exp file.");
+		_error_("Error reading exp file.");
 	_pprintLine_("Exp2Kmlx -- Reading " << nprof << " exp profiles from file \"" << filexp << "\".");
 //	for (i=0; i<nprof; i++)
Index: issm/trunk/src/c/modules/Exp2Kmlx/Exp2Kmlx.h
===================================================================
--- issm/trunk/src/c/modules/Exp2Kmlx/Exp2Kmlx.h	(revision 12709)
+++ issm/trunk/src/c/modules/Exp2Kmlx/Exp2Kmlx.h	(revision 13395)
@@ -8,5 +8,5 @@
 #include <float.h>    /*  DBL_MAX  */
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/GetSolutionFromInputsx/GetSolutionFromInputsx.cpp
===================================================================
--- issm/trunk/src/c/modules/GetSolutionFromInputsx/GetSolutionFromInputsx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/GetSolutionFromInputsx/GetSolutionFromInputsx.cpp	(revision 13395)
@@ -9,5 +9,5 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void	GetSolutionFromInputsx( Vector** psolution, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters){
+void	GetSolutionFromInputsx( Vector<IssmDouble>** psolution, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters){
 
 	/*intermediary: */
@@ -19,5 +19,5 @@
 
 	/*output: */
-	Vector* solution=NULL;
+	Vector<IssmDouble>* solution=NULL;
 
 	/*retrive parameters: */
@@ -26,8 +26,8 @@
 	/*Get size of vector: */
 	gsize=nodes->NumberOfDofs(configuration_type,GsetEnum);
-	if (gsize==0) _error2_("Allocating a Vec of size 0 as gsize=0 for configuration: " << EnumToStringx(configuration_type));
+	if (gsize==0) _error_("Allocating a Vec of size 0 as gsize=0 for configuration: " << EnumToStringx(configuration_type));
 	
 	/*Initialize solution: */
-	solution=new Vector(gsize);
+	solution=new Vector<IssmDouble>(gsize);
 	
 	/*Go through elements and plug solution: */
Index: issm/trunk/src/c/modules/GetSolutionFromInputsx/GetSolutionFromInputsx.h
===================================================================
--- issm/trunk/src/c/modules/GetSolutionFromInputsx/GetSolutionFromInputsx.h	(revision 12709)
+++ issm/trunk/src/c/modules/GetSolutionFromInputsx/GetSolutionFromInputsx.h	(revision 13395)
@@ -6,9 +6,9 @@
 #define _GETSOLUTIONFROMINPUTSXX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
 /* local prototypes: */
-void GetSolutionFromInputsx( Vector** psolution, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters);
+void GetSolutionFromInputsx( Vector<IssmDouble>** psolution, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters);
 
 #endif  /* _GETSOLUTIONFROMINPUTSXX_H */
Index: issm/trunk/src/c/modules/GetVectorFromControlInputsx/GetVectorFromControlInputsx.cpp
===================================================================
--- issm/trunk/src/c/modules/GetVectorFromControlInputsx/GetVectorFromControlInputsx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/GetVectorFromControlInputsx/GetVectorFromControlInputsx.cpp	(revision 13395)
@@ -9,9 +9,9 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void GetVectorFromControlInputsx(Vector** pvector, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,const char* data){
+void GetVectorFromControlInputsx(Vector<IssmDouble>** pvector, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,const char* data){
 
 	int  num_controls;
 	int *control_type = NULL;
-	Vector*  vector=NULL;
+	Vector<IssmDouble>*  vector=NULL;
 
 	/*Retrieve some parameters*/
@@ -20,5 +20,5 @@
 
 	/*Allocate and populate gradient*/
-	vector=new Vector(num_controls*vertices->NumberOfVertices());
+	vector=new Vector<IssmDouble>(num_controls*vertices->NumberOfVertices());
 
 	for(int i=0;i<num_controls;i++){
@@ -36,11 +36,11 @@
 }
 
-void GetVectorFromControlInputsx( double** pvector, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters, const char* data){
+void GetVectorFromControlInputsx( IssmDouble** pvector, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters, const char* data){
 	
 	/*output: */
-	double* vector=NULL;
+	IssmDouble* vector=NULL;
 	
 	/*intermediary: */
-	Vector* vec_vector=NULL;
+	Vector<IssmDouble>* vec_vector=NULL;
 
 	GetVectorFromControlInputsx( &vec_vector, elements,nodes, vertices, loads, materials, parameters,data);
Index: issm/trunk/src/c/modules/GetVectorFromControlInputsx/GetVectorFromControlInputsx.h
===================================================================
--- issm/trunk/src/c/modules/GetVectorFromControlInputsx/GetVectorFromControlInputsx.h	(revision 12709)
+++ issm/trunk/src/c/modules/GetVectorFromControlInputsx/GetVectorFromControlInputsx.h	(revision 13395)
@@ -5,10 +5,10 @@
 #define _GETVECTORFROMCONTROLINPUTSXX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
 /* local prototypes: */
-void	GetVectorFromControlInputsx( Vector** pvector, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,const char* data="value");
-void	GetVectorFromControlInputsx( double** pvector, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,const char* data="value");
+void	GetVectorFromControlInputsx( Vector<IssmDouble>** pvector, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,const char* data="value");
+void	GetVectorFromControlInputsx( IssmDouble** pvector, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,const char* data="value");
 
 #endif  /* _GETVECTORFROMCONTROLINPUTSXX_H */
Index: issm/trunk/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.cpp
===================================================================
--- issm/trunk/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.cpp	(revision 13395)
@@ -9,13 +9,13 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void GetVectorFromInputsx( Vector** pvector, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters, int name, int type){
+void GetVectorFromInputsx( Vector<IssmDouble>** pvector, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters, int name, int type){
 
 	int i;
-	Vector* vector=NULL;
+	Vector<IssmDouble>* vector=NULL;
 
 	if(type==VertexEnum){
 
 		/*Allocate vector*/
-		vector=new Vector(vertices->NumberOfVertices());
+		vector=new Vector<IssmDouble>(vertices->NumberOfVertices());
 
 		/*Look up in elements*/
@@ -32,5 +32,5 @@
 	}
 	else{
-		_error2_("vector type: " << EnumToStringx(type) << " not supported yet!");
+		_error_("vector type: " << EnumToStringx(type) << " not supported yet!");
 	}
 
@@ -47,5 +47,5 @@
 	
 	/*intermediary: */
-	Vector* vec_vector=NULL;
+	Vector<IssmDouble>* vec_vector=NULL;
 
 	GetVectorFromInputsx( &vec_vector, elements,nodes, vertices, loads, materials, parameters, name, type);
Index: issm/trunk/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.h
===================================================================
--- issm/trunk/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.h	(revision 12709)
+++ issm/trunk/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.h	(revision 13395)
@@ -5,9 +5,9 @@
 #define _GETVECTORFROMINPUTSXX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
 /* local prototypes: */
-void	GetVectorFromInputsx( Vector** pvector, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,int name,int type);
+void	GetVectorFromInputsx( Vector<IssmDouble>** pvector, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,int name,int type);
 void	GetVectorFromInputsx( IssmDouble** pvector, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,int name,int type);
 
Index: issm/trunk/src/c/modules/Gradjx/Gradjx.cpp
===================================================================
--- issm/trunk/src/c/modules/Gradjx/Gradjx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/Gradjx/Gradjx.cpp	(revision 13395)
@@ -10,13 +10,13 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void Gradjx(Vector** pgradient,double** pnorm_list, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters){
+void Gradjx(Vector<IssmDouble>** pgradient,IssmDouble** pnorm_list, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters){
 
 	int     i,j,numberofvertices;
 	int     num_controls;
-	double   norm_inf;
-	double  *norm_list     = NULL;
+	IssmDouble   norm_inf;
+	IssmDouble  *norm_list     = NULL;
 	int     *control_type  = NULL;
-	Vector  *gradient      = NULL;
-	Vector **gradient_list = NULL;
+	Vector<IssmDouble>  *gradient      = NULL;
+	Vector<IssmDouble> **gradient_list = NULL;
 	
 	/*retrieve some parameters: */
@@ -26,10 +26,10 @@
 
 	/*Allocate gradient_list */
-	gradient_list = xNew<Vector*>(num_controls);
-	norm_list = xNew<double>(num_controls);
+	gradient_list = xNew<Vector<IssmDouble>*>(num_controls);
+	norm_list = xNew<IssmDouble>(num_controls);
 	for(i=0;i<num_controls;i++){
-		gradient_list[i]=new Vector(num_controls*numberofvertices);
+		gradient_list[i]=new Vector<IssmDouble>(num_controls*numberofvertices);
 	}
-	gradient=new Vector(num_controls*numberofvertices);
+	gradient=new Vector<IssmDouble>(num_controls*numberofvertices);
 
 	/*Compute all gradient_list*/
@@ -54,6 +54,6 @@
 	/*Check that gradient is clean*/
 	norm_inf=gradient->Norm(NORM_INF);
-	if(norm_inf<=0)    _error2_("||∂J/∂α||∞ = 0    gradient norm is zero");
-	if(xIsNan<IssmDouble>(norm_inf))_error2_("||∂J/∂α||∞ = NaN  gradient norm is NaN");
+	if(norm_inf<=0)    _error_("||∂J/∂α||∞ = 0    gradient norm is zero");
+	if(xIsNan<IssmDouble>(norm_inf))_error_("||∂J/∂α||∞ = NaN  gradient norm is NaN");
 
 	/*Clean-up and assign output pointer*/
@@ -62,8 +62,8 @@
 	}
 	else{
-		xDelete<double>(norm_list);
+		xDelete<IssmDouble>(norm_list);
 	}
 	if(pgradient)  *pgradient=gradient;
-	xDelete<Vector*>(gradient_list);
+	xDelete<Vector<IssmDouble>*>(gradient_list);
 	xDelete<int>(control_type);
 }
Index: issm/trunk/src/c/modules/Gradjx/Gradjx.h
===================================================================
--- issm/trunk/src/c/modules/Gradjx/Gradjx.h	(revision 12709)
+++ issm/trunk/src/c/modules/Gradjx/Gradjx.h	(revision 13395)
@@ -7,8 +7,8 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void Gradjx(Vector** pgrad_g,double** pgrad_norm,Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters);
+void Gradjx(Vector<IssmDouble>** pgrad_g,IssmDouble** pgrad_norm,Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters);
 
 #endif  /* _GRADJX_H */
Index: issm/trunk/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp
===================================================================
--- issm/trunk/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp	(revision 13395)
@@ -14,8 +14,8 @@
 
 	int      i, migration_style,analysis_type;
-	double*  vertices_potentially_ungrounding = NULL;
-	double*  vertices_ungrounding             = NULL;
-	double*  old_floatingice                  = NULL;
-	Vector*      vec_old_floatingice              = NULL;
+	IssmDouble*  vertices_potentially_ungrounding = NULL;
+	IssmDouble*  vertices_ungrounding             = NULL;
+	IssmDouble*  old_floatingice                  = NULL;
+	Vector<IssmDouble>*      vec_old_floatingice              = NULL;
 	Element* element                          = NULL;
 	
@@ -27,5 +27,5 @@
 
 	if(migration_style==NoneEnum) return;
-	if(migration_style!=AgressiveMigrationEnum && migration_style!=SoftMigrationEnum) _error2_(EnumToStringx(migration_style) << " not supported yet!");
+	if(migration_style!=AgressiveMigrationEnum && migration_style!=SoftMigrationEnum) _error_(EnumToStringx(migration_style) << " not supported yet!");
 
 	if(migration_style==SoftMigrationEnum){
@@ -49,19 +49,19 @@
 	/*free ressouces: */
 	xdelete(&vec_old_floatingice);
-	xDelete<double>(vertices_potentially_ungrounding);
-	xDelete<double>(vertices_ungrounding);
-	xDelete<double>(old_floatingice);
+	xDelete<IssmDouble>(vertices_potentially_ungrounding);
+	xDelete<IssmDouble>(vertices_ungrounding);
+	xDelete<IssmDouble>(old_floatingice);
 }
 
 /*FUNCTION CreateNodesOnFloatingIce {{{*/
-Vector* CreateNodesOnFloatingIce(Nodes* nodes,int configuration_type){ 
+Vector<IssmDouble>* CreateNodesOnFloatingIce(Nodes* nodes,int configuration_type){ 
 
 	int     i,numnods;
-	Vector*   vec_nodes_on_floatingice = NULL;
+	Vector<IssmDouble>*   vec_nodes_on_floatingice = NULL;
 	Node *node                     = NULL;
 
 	/*First, initialize nodes_on_floatingice, which will track which nodes have changed status: */
 	numnods=nodes->NumberOfNodes(configuration_type);
-	vec_nodes_on_floatingice=new Vector(numnods);
+	vec_nodes_on_floatingice=new Vector<IssmDouble>(numnods);
 
 	/*Loop through nodes, and fill vec_nodes_on_floatingice: */
@@ -82,14 +82,14 @@
 /*%}}}*/
 /*FUNCTION PotentialSheetUngrounding {{{*/
-double*    PotentialSheetUngrounding(Elements* elements,Vertices* vertices,Parameters* parameters){ 
+IssmDouble*    PotentialSheetUngrounding(Elements* elements,Vertices* vertices,Parameters* parameters){ 
 
 	int      i,numberofvertices;
-	double*  vertices_potentially_ungrounding      = NULL;
-	Vector*      vec_vertices_potentially_ungrounding  = NULL;
+	IssmDouble*  vertices_potentially_ungrounding      = NULL;
+	Vector<IssmDouble>*      vec_vertices_potentially_ungrounding  = NULL;
 	Element* element                               = NULL;
 
 	/*Initialize vector with number of vertices*/
 	numberofvertices=vertices->NumberOfVertices();
-	vec_vertices_potentially_ungrounding=new Vector(numberofvertices); //grounded vertex that could start floating
+	vec_vertices_potentially_ungrounding=new Vector<IssmDouble>(numberofvertices); //grounded vertex that could start floating
 
 	/*Fill vector vertices_potentially_floating: */
@@ -109,13 +109,13 @@
 /*}}}*/
 /*FUNCTION PropagateFloatingiceToGroundedNeighbors {{{*/
-double*    PropagateFloatingiceToGroundedNeighbors(Elements* elements,Nodes* nodes,Vertices* vertices,Parameters* parameters,double* vertices_potentially_ungrounding){ 
+IssmDouble*    PropagateFloatingiceToGroundedNeighbors(Elements* elements,Nodes* nodes,Vertices* vertices,Parameters* parameters,IssmDouble* vertices_potentially_ungrounding){ 
 
 	int      i,analysis_type;
 	int      numberofvertices;
 	int      nflipped,local_nflipped;
-	double*  nodes_on_floatingice                  = NULL;
-	double*  elements_neighboring_floatingce      = NULL;
-	Vector*      vec_elements_neighboring_floatingice = NULL;
-	Vector*      vec_nodes_on_floatingice              = NULL;
+	IssmDouble*  nodes_on_floatingice                  = NULL;
+	IssmDouble*  elements_neighboring_floatingce      = NULL;
+	Vector<IssmDouble>*      vec_elements_neighboring_floatingice = NULL;
+	Vector<IssmDouble>*      vec_nodes_on_floatingice              = NULL;
 	Node*    node                                  = NULL;
 	Element* element                               = NULL;
@@ -134,5 +134,5 @@
 		
 		/*Vector of size number of elements*/
-		vec_elements_neighboring_floatingice=new Vector(elements->NumberOfElements(),true);
+		vec_elements_neighboring_floatingice=new Vector<IssmDouble>(elements->NumberOfElements(),true);
 
 		/*Figure out if any of the nodes of the element will be floating -> elements neighbouting the floating ice*/
@@ -150,5 +150,5 @@
 		for(i=0;i<elements->Size();i++){
 			element=(Element*)elements->GetObjectByOffset(i);
-			if(elements_neighboring_floatingce[element->Sid()]){
+			if(reCast<int,IssmDouble>(elements_neighboring_floatingce[element->Sid()])){
 				local_nflipped+=element->UpdatePotentialSheetUngrounding(vertices_potentially_ungrounding,vec_nodes_on_floatingice,nodes_on_floatingice);
 			}
@@ -164,6 +164,6 @@
 
 		/*Avoid leaks: */
-		xDelete<double>(elements_neighboring_floatingce);
-		xDelete<double>(nodes_on_floatingice);
+		xDelete<IssmDouble>(elements_neighboring_floatingce);
+		xDelete<IssmDouble>(nodes_on_floatingice);
 
 		/*Assemble and serialize:*/
@@ -174,5 +174,5 @@
 	/*Free ressources:*/
 	xdelete(&vec_nodes_on_floatingice);
-	xDelete<double>(elements_neighboring_floatingce);
+	xDelete<IssmDouble>(elements_neighboring_floatingce);
 
 	return nodes_on_floatingice;
Index: issm/trunk/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.h
===================================================================
--- issm/trunk/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.h	(revision 12709)
+++ issm/trunk/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.h	(revision 13395)
@@ -14,6 +14,6 @@
 void       GroundinglineMigrationx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters);
 
-Vector*        CreateNodesOnFloatingIce(Nodes* nodes,int configuration_type);
-double*    PotentialSheetUngrounding(Elements* elements,Vertices* vertices,Parameters* parameters);
-double*    PropagateFloatingiceToGroundedNeighbors(Elements* elements,Nodes* nodes,Vertices* vertices,Parameters* parameters,double* vertices_potentially_ungrounding);
+Vector<IssmDouble>*        CreateNodesOnFloatingIce(Nodes* nodes,int configuration_type);
+IssmDouble*    PotentialSheetUngrounding(Elements* elements,Vertices* vertices,Parameters* parameters);
+IssmDouble*    PropagateFloatingiceToGroundedNeighbors(Elements* elements,Nodes* nodes,Vertices* vertices,Parameters* parameters,IssmDouble* vertices_potentially_ungrounding);
 #endif  /* _GROUNDINGLINEMIGRATIONX_H */
Index: issm/trunk/src/c/modules/IceVolumex/IceVolumex.cpp
===================================================================
--- issm/trunk/src/c/modules/IceVolumex/IceVolumex.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/IceVolumex/IceVolumex.cpp	(revision 13395)
@@ -10,8 +10,8 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void IceVolumex(double* pV, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units){
+void IceVolumex(IssmDouble* pV, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units){
 
-	double local_ice_volume = 0;
-	double total_ice_volume;
+	IssmDouble local_ice_volume = 0;
+	IssmDouble total_ice_volume;
 
 	for(int i=0;i<elements->Size();i++){
Index: issm/trunk/src/c/modules/IceVolumex/IceVolumex.h
===================================================================
--- issm/trunk/src/c/modules/IceVolumex/IceVolumex.h	(revision 12709)
+++ issm/trunk/src/c/modules/IceVolumex/IceVolumex.h	(revision 13395)
@@ -7,8 +7,8 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void IceVolumex(double* pV, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units);
+void IceVolumex(IssmDouble* pV, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units);
 
 #endif
